//------------------------------------------------------------------
// Copyright 2002, softSurfer (www.softsurfer.com)
// This code may be freely used and modified for any purpose
// providing that this copyright notice is included with it.
// SoftSurfer makes no warranty for this code, and cannot be held
// liable for any real or imagined damage resulting from it's use.
// Users of this code must verify correctness for their application.
//------------------------------------------------------------------

#ifndef SS_Common_H
#define SS_Common_H

#include <stdio.h>
#include <math.h>
#include <iostream>
#include <ostream>


#define DIM3 3
#define DIM4 4
#define MATRIX_DIM 4

#include "vector4.h"
#include "vector3.h"
#include "matrix4.h"

// utility macros
#define	abs(x)		((x) >= 0 ? x : -(x));
#define	min(x,y)	((x) < (y) ? (x) : (y));
#define	max(x,y)	((x) > (y) ? (x) : (y));
inline float deg2rad(float degree){return degree/360.0*2*M_PI;}

#endif SS_Common_H
