//==================================================================
//==================================================================

#include "common.h"
using namespace std;

//==================================================================
// Frustrum Class Methods
//==================================================================


			//fovy, aspect, zNear, zFar

void	Frustrum::set(double f, double a, double n, double fa){
	
	fov = f;
	aspect = a;
	near = n;
	far = f;
	regen();
	
}
	
void	Frustrum::regen(){
	double t;
	//set to 0
	Ppersp.set_to(0);
	
	//cout << "(tan(fov/2)) = " << (tan(deg2rad(fov/2))) << endl;
	t = 1 / (aspect * tan(deg2rad(fov/2)));
	
	//cout << "(0,0) = " << t << endl;
	Ppersp.set(0, 0, t);
	
	t = 1 / (tan(deg2rad(fov/2)));
	Ppersp.set(1, 1, t);
	
	t = (near + far) / (near - far);
	Ppersp.set(2, 2, t);
	Ppersp.set(3, 2, -1);
	//Ppersp.set(3, 3, 1);
	
	t = (2 * near * far) / (near - far);
	Ppersp.set(2, 3, t);
	
}




//------------------------------------------------------------------
//  Special
//------------------------------------------------------------------

// Write output Matrix
std::ostream& operator<<(std::ostream &out, Frustrum &frust) {
	out << "Frust(m:";

	cout << frust.Ppersp;
	
	out << ")";
	return out;
}
