//==================================================================
//==================================================================

#include "common.h"
using namespace std;

//==================================================================
// Group Class Methods
//==================================================================

//----------------------------------------------------------
//  add/remove Nodes
void Group::removeNode(Node *n){

	int idx = findNodeIndex(n);
	if (idx > -1)
		removeNode(idx);
	
}

void Group::addNode(Node *n){
	
	childNodes.insert(childNodes.end(), n);
	
}


void Group::removeNode(int idx){
	
	childNodes.erase (childNodes.begin() + idx);
	
}


int Group::findNodeIndex(Node *n){
	
	int i;
	for (i=0; i<childNodes.size(); i++)
		if (childNodes[i] == n) return i;
	
	return -1;
}

 /*
bool Group::operator==( Group o)
{	//always return false
	return false;
}

bool Group::operator!=( Group other)
{
	return !(*this == other);
}




//abstract, so no draw for Group!
//draws this Group, should be overriden by all subclasses
void Group::draw(Matrix4 C){
	int i;
	
	//just call draw on all children
	for (i=0; i<childNodes.size(); i++)
		childNodes[i].draw(C);
	
}
*/