//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Group_H
#define SS_Group_H


using namespace std;

//==================================================================
//  Group Class Definition
//==================================================================

class Group : public Node {
	
	protected:
		//child nodes
		vector<Node*> childNodes;
	
public:
	//----------------------------------------------------------
	//  ctor
	Group() { 
		cout << "ctor in Group called!" << endl;
	}
	
	// Destructor
	~Group() {};

	//----------------------------------------------------------
	//  add/remove Nodes
	void addNode(Node*);
	void removeNode(Node*);
	void removeNode(int);
	int findNodeIndex(Node*);
	
	vector<Node*> getChildren() { return childNodes; }
	
	//draws this node, should be overriden by all subclasses
	virtual void draw(Matrix4) = 0;
	
	// Comparison 
	//virtual bool operator==( Node ) = 0;
	//virtual bool operator!=( Node ) = 0;

	
};
#endif SS_Group_H