//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Shape3D_H
#define SS_Shape3D_H


using namespace std;

//==================================================================
//  Shape3D Class Definition
//==================================================================

class Shape3D : public Leaf {
	
	protected:
		//our object
		Object3D *obj;
	
public:
	//----------------------------------------------------------
	Shape3D() { }
	
	Shape3D(Object3D *o) { obj = o; }
	// Destructor
	~Shape3D() {};

	Object3D *getObj() { return obj; }
	//draws this node, should be overriden by all subclasses
	void draw(Matrix4);
	
	// Comparison 
	bool operator==( Shape3D );
	bool operator!=( Shape3D );
	bool operator==( Node* ){ return false;}
	bool operator!=( Node* ){ return true;}
	
	
};
#endif SS_Shape3D_H