//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Sphere_H
#define SS_Sphere_H


using namespace std;

//==================================================================
//  Sphere Class Definition
//==================================================================

class Sphere : public Object3D {
	
	protected:
		double radius;

public:
	//----------------------------------------------------------
	//  ctor: creates unit square
	Sphere() { radius = 1.0; }
	
	Sphere(double r) { radius = r; }
	
	
	// Destructor
	~Sphere() {};

	//----------------------------------------------------------
	//  draw
	void draw();
	double getRadius() { return radius; }
	// Comparison 
	bool operator==( Sphere );
	bool operator!=( Sphere );
	bool operator==( Object3D* ){ return false;}
	bool operator!=( Object3D* ){ return true;}

	
};
#endif SS_Sphere_H