//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Frust_H
#define SS_Frust_H


//==================================================================
//  Frustrum Class Definition
//==================================================================

class Frustrum {
	
	protected:


		//Projection matrix
		Matrix4 Ppersp;
		
		
	public:
	

		//generates the projection matrix from near, far, aspect and fov
		
		void generate(double, double, double, double);
		void set_OGL(){
			glMatrixMode(GL_PROJECTION);
			glLoadMatrixd(Ppersp.GL_matrix());
		}



		//----------------------------------------------------------
		// Special Operations
		friend std::ostream &operator<<(std::ostream &out, Frustrum &fru);





};


#endif SS_Frust_H
