//==================================================================
//==================================================================

#include "common.h"
using namespace std;

//==================================================================
// Viewport Class Methods
//==================================================================


void Viewport::recalcVPMat(){
	
	//recalculate the internal viewport Matrix
	double t;
	viewport_mat.set_to(0);
	
	t = (width-1) / 2;
	
	viewport_mat.set(0, 0, t);
	viewport_mat.set(0, 3, t);
	
	t = (height-1) / 2;
	viewport_mat.set(1, 3, t);
	viewport_mat.set(1, 1, t);
	
	viewport_mat.set(2, 2, 0.5);
	viewport_mat.set(2, 3, 0.5);
	viewport_mat.set(3, 3, 1);
	
	
}




//------------------------------------------------------------------
//  Special
//------------------------------------------------------------------

// Write output Matrix
std::ostream& operator<<(std::ostream &out, Viewport &vp) {
	out << "VP(mat:";

	cout << vp.viewport_mat;
	
	out << ")";
	return out;
}
