//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Node_H
#define SS_Node_H


using namespace std;

//==================================================================
//  Node Class Definition
//==================================================================

class Node {
	
	protected:
public:
	string tagName;
	//----------------------------------------------------------
	Node() { 
		tagName = "tag";
		cout << "ctor in Node called, settting name to "<< tagName << "!" << endl;
		
	}
	
	// Destructor
	~Node() {};


	//draws this node, should be overriden by all subclasses
	//mark as virtual to dispatch based on actual instance's type
	virtual void draw(Matrix4) = 0;
	
	// Comparison 
	virtual bool operator==( Node* ) = 0;
	virtual bool operator!=( Node* ) = 0;
	void setName(string n){
		tagName = n;
		cout << "set Name to " << tagName << endl;
	}
	
};
#endif SS_Node_H