//==================================================================
//==================================================================

#include "common.h"
using namespace std;

//==================================================================
// Shape3D Class Methods
//==================================================================

void Shape3D::draw(Matrix4 C){

	cout << "draw called in Shape3D!" << endl;

	//set the model view for OpenGL
	glMatrixMode(GL_MODELVIEW); 
	// glLoadIdentity(); 
	
	glPushMatrix();
	
	//now set matrix
	//glLoadMatrixd(C.GL_matrix());
	glMultMatrixd(C.GL_matrix());
	//set Material as well
	//not used in Proj 5
	
	//and just call draw on the contained shape
	obj->draw();
	
	glPopMatrix();
}


//------------------------------------------------------------------
// Comparisons
//------------------------------------------------------------------

bool Shape3D::operator==( Shape3D o)
{
	
	//check if the objects are one the same
	if (obj == o.getObj()) return true;
	
	return false;
	
}

bool Shape3D::operator!=( Shape3D other)
{
	return !(*this == other);
}
