//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Box_H
#define SS_Box_H


using namespace std;

//==================================================================
//  Box Class Definition
//==================================================================

class Box : public Object3D {
	
	protected:
		double size;

public:
	//----------------------------------------------------------
	//  ctor creates unit box
	Box() { size = 1; }
	

	Box(double s) { size = s; }


	// Destructor
	~Box() {};

	//----------------------------------------------------------
	//  draw
	void draw();
	double getSize() { return size; }
	// Comparison 
	bool operator==( Box );
	bool operator!=( Box );
	bool operator==( Object3D* ){ return false;}
	bool operator!=( Object3D* ){ return true;}

	
};
#endif SS_Box_H