//==================================================================
//==================================================================

#include "../common.h"
using namespace std;

//==================================================================
// Cylinder Class Methods
//==================================================================

#define FACES 50

void Cylinder::draw(){
	cout << "draw called for Cyl(" << height << ", " << radius << ")!" << endl;
	GLUquadricObj* pObj;

	pObj = gluNewQuadric();
	gluQuadricDrawStyle(pObj, GLU_FILL);
	gluCylinder(pObj, radius, radius, height, FACES, FACES);
	
	gluDeleteQuadric(pObj);
	
}


bool Cylinder::operator==( Cylinder o)
{
	return (height == o.getHeight() && radius == o.getRadius() );
}

bool Cylinder::operator!=( Cylinder other)
{
	return !(*this == other);
}