//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Cylinder_H
#define SS_Cylinder_H


using namespace std;

//==================================================================
//  Cylinder Class Definition
//==================================================================

class Cylinder : public Object3D {
	
	protected:
		double height, radius;
	

public:
	//----------------------------------------------------------
	//  ctor
	Cylinder() { height = 1; radius = 1; }
	
	Cylinder(double h, double r) { height = h; radius = r; }
	
	// Destructor
	~Cylinder() {};

	//----------------------------------------------------------
	//  draw
	void draw();
	double getHeight() { return height; }
	double getRadius() { return radius; }
	// Comparison 
	bool operator==( Cylinder );
	bool operator!=( Cylinder );
	bool operator==( Object3D* ){ return false;}
	bool operator!=( Object3D* ){ return true;}

	
};
#endif SS_Cylinder_H