//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_TransformGroup_H
#define SS_TransformGroup_H


using namespace std;

//==================================================================
//  TransformGroup Class Definition
//==================================================================

class TransformGroup : public Group {
	
	public:
		Matrix4 M;
		
	//----------------------------------------------------------
	// ctor
	TransformGroup();
			
	// Destructor
	~TransformGroup() {};

	//draws this node, should be overriden by all subclasses
	void draw(Matrix4);
	
	// Comparison 
	bool operator==( TransformGroup );
	bool operator!=( TransformGroup );
	bool operator==( Node* ){return false;}
	bool operator!=( Node* ){return true;}
	
};
#endif SS_TransformGroup_H