#ifndef _PROJECT6_H_
#define _PROJECT6_H_


class Window	  // output window related routines
{
	
	
  public:
    static int width, height; 	            // window size
	static void light();
    static void idleCallback(void);
    static void reshapeCallback(int, int);
    static void displayCallback(void);
	static void keyboardFunc(unsigned char key, int, int);
	static void specialFunc(int, int, int);
	static void drawReferenceAxis();
	static void computeLocation();
	static GLuint LoadTexture(char *TexName);
};

void test_bezier();
void test_bezier1();
void test_bezierVertices();
void draw_bezierSurface();
void make_bezierSurface();
void initTextures();

#endif

